{-
HOpenGL - a binding of OpenGL and GLUT for Haskell.
Copyright (C) 2001  Sven Panne <Sven.Panne@BetaResearch.de>

This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Library General Public
License as published by the Free Software Foundation; either
version 2 of the License, or (at your option) any later version.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
Library General Public License for more details.

You should have received a copy of the GNU Library General Public
License along with this library (COPYING.LIB); if not, write to the Free
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

This module corresponds to section 2.11 (Clipping) of the OpenGL 1.2.1 specs.
-}

module GL_Clipping (
   ClipPlane(..), clipPlane
) where

import Foreign          ( Ptr, withObject )

import GL_Constants     ( gl_CLIP_PLANE0 )
import GL_BasicTypes    ( GLenum, GLdouble, Capability(..) )
import GL_CoordTrans    ( Plane )

---------------------------------------------------------------------------

newtype ClipPlane = ClipPlane Int   deriving (Eq,Ord)

instance Capability ClipPlane where
   marshalCapability (ClipPlane n) = gl_CLIP_PLANE0 + fromIntegral n   -- TODO: add check

clipPlane :: ClipPlane -> Plane GLdouble -> IO ()
clipPlane planeNo plane = withObject plane $ glClipPlane (marshalCapability planeNo)

foreign import "glClipPlane" unsafe glClipPlane :: GLenum -> Ptr (Plane GLdouble) -> IO ()
