% -----------------------------------------------------------------------------
% $Id: ForeignPtr.lhs,v 1.5 2001/03/22 03:51:12 hwloidl Exp $
%
% (c) The GRAP/AQUA Project, Glasgow University & The FFI task force, 2000
%

This module defines foreign pointers, i.e. addresses with associated
finalizers.

At the moment we cannot use ForeignPtrs in GUM/GranSim, sorry.

\begin{code}
module ForeignPtr
        ( ForeignPtr,            -- abstract, instance of: Eq
        , newForeignPtr          -- :: Ptr a -> IO () -> IO (ForeignPtr a)
        , addForeignPtrFinalizer -- :: ForeignPtr a -> IO () -> IO ()
	, withForeignPtr         -- :: ForeignPtr a -> (Ptr a -> IO b) -> IO b
	, foreignPtrToPtr	 -- :: ForeignPtr a -> Ptr a
	, touchForeignPtr        -- :: ForeignPtr a -> IO ()
	, castForeignPtr	 -- :: ForeignPtr a -> ForeignPtr b
        ) 
	where

import PrelForeign
import PrelIOBase
\end{code}
