% -----------------------------------------------------------------------------
% $Id: MarshalError.lhs,v 1.2 2001/01/11 17:25:58 simonmar Exp $
%
% (c) The FFI task force, 2000
%

Marshalling support: Handling of common error conditions

\begin{code}

module MarshalError (

  -- throw an exception on specific return values
  --
  throwIf,       -- :: (a -> Bool) -> (a -> String) -> IO a       -> IO a
  throwIf_,      -- :: (a -> Bool) -> (a -> String) -> IO a       -> IO ()
  throwIfNeg,    -- :: (Ord a, Num a) 
	         -- =>                (a -> String) -> IO a       -> IO a
  throwIfNeg_,   -- :: (Ord a, Num a)
	         -- =>                (a -> String) -> IO a       -> IO ()
  throwIfNull,   -- ::                String        -> IO (Ptr a) -> IO (Ptr a)

  -- discard return value
  --
  void           -- IO a -> IO ()
) where

import PrelMarshalError
\end{code}
